% esercitazione ODE: ex1
%h=[0.1 0.25 0.5 0.75];
h=[0.025 0.05 0.1 0.2];
[t1,y1]=heun(@fex1,[0,3],1, h(1));
e(1)=norm(1./(1+t1.^2)-y1);
[t2,y2]=heun(@fex1,[0,3],1, h(2));
e(2)=norm(1./(1+t2.^2)-y2);
[t3,y3]=heun(@fex1,[0,3],1, h(3));
e(3)=norm(1./(1+t3.^2)-y3);
[t4,y4]=heun(@fex1,[0,3],1, h(4));
e(4)=norm(1./(1+t4.^2)-y4);
plot(t1,1./(1+t1.^2),'-.',t1,y1,t2,y2,t3,y3,t4,y4)
legend('soluzione esatta','passo h=0.1','passo h=0.25','passo h=0.50','passo h=0.75');
title(' Metodo di Heun');
for i=2:4
    p_ee=log(e(i-1)/e(i))/log(h(i-1)/h(i))
end

%% Eulero esplicito per valori crescenti del passo h
[t1,y1]=eul_esp(@fex1,[0,3],1, 0.1);
[t2,y2]=eul_esp(@fex1,[0,3],1, 0.25);
[t3,y3]=eul_esp(@fex1,[0,3],1, 0.5);
[t4,y4]=eul_esp(@fex1,[0,3],1, 0.75);
figure;
plot(t1,1./(1+t1.^2),'-.',t1,y1,t2,y2,t3,y3,t4,y4)
legend('soluzione esatta','passo h=0.1','passo h=0.25','passo h=0.50','passo h=0.75');
title(' Metodo di Eulero Esplicito');

%% Eulero implicito per valori crescenti del passo h
[t1,y1]=eul_imp(@fex1,@jacf_ex1,[0,3],1, 0.1);
[t2,y2]=eul_imp(@fex1,@jacf_ex1,[0,3],1, 0.25);
[t3,y3]=eul_imp(@fex1,@jacf_ex1,[0,3],1, 0.5);
[t4,y4]=eul_imp(@fex1,@jacf_ex1,[0,3],1, 0.75);
figure;
plot(t1,1./(1+t1.^2),'-.',t1,y1,t2,y2,t3,y3,t4,y4)
legend('soluzione esatta','passo h=0.1','passo h=0.25','passo h=0.50','passo h=0.75');
title(' Metodo di Eulero Implicito');

%% soluzione esatta
dsolve('Dy+2*t*y^2=0','y(0)=1')

%% ordine di consistenza empirico di Heun
h=[0.05 0.1 0.2 0.4];
%h=[0.025 0.05 0.1 0.2];
[t1,y1]=heun(@fex1,[0,3],1, 0.1);
e(1)=norm(1./(1+t1.^2)-y1);
[t2,y2]=heun(@fex1,[0,3],1, 0.25);
e(2)=norm(1./(1+t2.^2)-y2);
[t3,y3]=heun(@fex1,[0,3],1, 0.5);
e(3)=norm(1./(1+t3.^2)-y3);
[t4,y4]=heun(@fex1,[0,3],1, 0.75);
e(4)=norm(1./(1+t4.^2)-y4);
for i=2:4
    p_heun=log(e(i-1)/e(i))/log(h(i-1)/h(i))
end
