% Problema del paracadutista
g = 9.81;
K = 1/15;
M = 80;
y0 = 600;
y0p = 0;
% 

[t,y] = ode23(@paraf,[0 5],[y0 y0p]',[],K/M);
y1 = y(end,1);
y1p = y(end,2);

K = 4/15;
opts = odeset('events',@gstop);
[t2,y2,tf,yf] = ode23(@paraf,[5 Inf],[y1 y1p]',opts,K/M);
tf
yf
t = [t; t2];
y = [y; y2];

% calcolo (non richiesto) della caduta libera (senza paracadute)
tfree = sqrt(2*y0/g)
yfree = y0 - g/2*t.^2;
yfreef = [0 -g*tfree]

% grafico altezza in funzione del tempo
hold on
plot(5,y1,'*k')
plot(tf,0,'ok')
text(5.5,y1,sprintf('y(5) = %5.1f',y1))
text(tf,65,sprintf('tf = %5.2f',tf))
text(tf,35,sprintf('y''(tf) = %5.2f',yf(2)))
text(7,65,sprintf('tf = %5.2f',tfree))
text(7,35,sprintf('y''(tf) = %5.2f',-g*tfree))
axis([0 18 0 y0])
box on
plot(t,y(:,1),'b')
plot(t,yfree,':m');

xlabel('tempo (s)')
ylabel('altezza (m)')
title('Paracadutista')

